# mediatek boot

Bootloader artifacts for MediaTek boards.

## Supported devices

* Genio 350 EVK (MT8365)
* Genio 510 EVK (MT8370)
* Genio 700 EVK (MT8390)
* Genio 1200 EVK (MT8395)
* Radxa NIO 12L (MT8395)

## Artifacts

Download the latest artifacts from:
* Genio 350 EVK (MT8365)
  https://gitlab.collabora.com/mediatek/aiot/boot/-/jobs/artifacts/main/download?job=pack-genio-350-evk
* Genio 510 EVK (MT8370)
  https://gitlab.collabora.com/mediatek/aiot/boot/-/jobs/artifacts/main/download?job=pack-genio-510-evk
* Genio 700 EVK (MT8390)
  https://gitlab.collabora.com/mediatek/aiot/boot/-/jobs/artifacts/main/download?job=pack-genio-700-evk
* Genio 1200 EVK (MT8395)
  https://gitlab.collabora.com/mediatek/aiot/boot/-/jobs/artifacts/main/download?job=pack-genio-1200-evk
* Radxa NIO 12L (MT8395)
  https://gitlab.collabora.com/mediatek/aiot/boot/-/jobs/artifacts/main/download?job=pack-radxa-nio-12l

### Files

```
$ tree
.
├── fip.img
└── lk.bin

1 directory, 2 files
```

* `lk.bin`: Little Kernel binaries, used to bootstrap into fastboot.
* `fip.img`: Binary image with ATF BL2 stage and `bl2.img` and BL3* loaders
  (BL31, BL32, BL33)

## Flash firmware

Clone [mediatek-brom](https://github.com/boardswarm/mediatek-brom) project and
run the following command using the downloaded artifacts:

```
$ cargo run --release --features="tokio" --example upload_da /dev/ttyACM0 <lk.bin>
    Finished `release` profile [optimized] target(s) in 0.02s
     Running `target/release/examples/upload_da /dev/ttyACM0 lk.bin`
Hwcode: HwCode { code: 8188, version: 0 }
Uploading DA to 2101248
Executing DA
```

Then flash `fip.img` to **mmc bootpart 0** using `fastboot`:

```
$ fastboot flash mmc0boot0 <fip.img>
Warning: skip copying mmc0boot0 image avb footer (mmc0boot0 partition size: 0, mmc0boot0 image size: 2927152).
Sending 'mmc0boot0' (2858 KB)                      OKAY [  0.094s]
Writing 'mmc0boot0'                                OKAY [  0.120s]
Finished. Total time: 0.227s
```
